'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _graphqlQueryCompress = _interopRequireDefault(require("graphql-query-compress"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default(api) {
  let changed = [];
  return {
    name: 'transform-compress-graphql',
    visitor: {
      Program: {
        enter: () => {
          changed = [];
        },
        exit: () => {// log what's changed?
        }
      },

      TaggedTemplateExpression(path, state) {
        const _path$node = path.node,
              tag = _path$node.tag,
              quasi = _path$node.quasi;
        const _state$opts = state.opts,
              _state$opts$tagName = _state$opts.tagName,
              tagName = _state$opts$tagName === void 0 ? 'gql' : _state$opts$tagName,
              _state$opts$tagFuncti = _state$opts.tagFunction,
              tagFunction = _state$opts$tagFuncti === void 0 ? '' : _state$opts$tagFuncti;

        if (tag.name === tagName) {
          quasi.quasis.map(({
            value
          }) => {
            const part = (0, _graphqlQueryCompress.default)(value.raw).trim();
            value.raw = part;
            value.cooked = part;
          });

          if (!path.scope.hasBinding(tagName)) {
            if (tagFunction) {
              // we have an actual tag function, update the name to match it
              tag.name = tagFunction;
            } else {
              // tag function is empty, replace the TaggedTemplateExpression
              // with the nested TemplateLiteral.
              path.replaceWith(quasi);
            }
          }
        }
      }

    }
  };
}